/**
 * POCDMT000040Observation.java
 *
 * File generated from the cdaepsos::POCDMT000040Observation uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class POCDMT000040Observation.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Observation", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"derivationExpr",
	"text",
	"statusCode",
	"effectiveTime",
	"priorityCode",
	"repeatNumber",
	"languageCode",
	"value",
	"interpretationCode",
	"methodCode",
	"targetSiteCode",
	"subject",
	"specimen",
	"performer",
	"author",
	"informant",
	"participant",
	"entryRelationship",
	"reference",
	"precondition",
	"referenceRange",
	"classCode",
	"moodCode",
	"negationInd",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.Observation")
public class POCDMT000040Observation implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> id;
	@XmlElement(name = "code", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CD code;
	@XmlElement(name = "derivationExpr", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.ST derivationExpr;
	@XmlElement(name = "text", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.ED text;
	@XmlElement(name = "statusCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CS statusCode;
	@XmlElement(name = "effectiveTime", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.IVLTS effectiveTime;
	@XmlElement(name = "priorityCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE priorityCode;
	@XmlElement(name = "repeatNumber", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.IVLINT repeatNumber;
	@XmlElement(name = "languageCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CS languageCode;
	@XmlElement(name = "value", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.ANY> value;
	@XmlElement(name = "interpretationCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CE> interpretationCode;
	@XmlElement(name = "methodCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CE> methodCode;
	@XmlElement(name = "targetSiteCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CD> targetSiteCode;
	@XmlElement(name = "subject", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cda.POCDMT000040Subject subject;
	@XmlElement(name = "specimen", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040Specimen> specimen;
	@XmlElement(name = "performer", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040Performer2> performer;
	@XmlElement(name = "author", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040Author> author;
	@XmlElement(name = "informant", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040Informant12> informant;
	@XmlElement(name = "participant", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040Participant2> participant;
	@XmlElement(name = "entryRelationship", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship> entryRelationship;
	@XmlElement(name = "reference", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040Reference> reference;
	@XmlElement(name = "precondition", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040Precondition> precondition;
	@XmlElement(name = "referenceRange", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cda.POCDMT000040ReferenceRange> referenceRange;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.voc.ActClassObservation classCode;
	@XmlAttribute(name = "moodCode", required = true)
	public net.ihe.gazelle.voc.XActMoodDocumentObservation moodCode;
	@XmlAttribute(name = "negationInd")
	public Boolean negationInd;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.templateId.add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.templateId.remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public List<net.ihe.gazelle.datatypes.II> getId() {
		if (id == null) {
	        id = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(List<net.ihe.gazelle.datatypes.II> id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Add a id to the id collection.
	 * @param id_elt Element to add.
	 */
	public void addId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.id.add(id_elt);
	}
	
	/**
	 * Remove a id to the id collection.
	 * @param id_elt Element to remove
	 */
	public void removeId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.id.remove(id_elt);
	}
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.datatypes.CD getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.datatypes.CD code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return derivationExpr.
	 * @return derivationExpr
	 */
	public net.ihe.gazelle.datatypes.ST getDerivationExpr() {
	    return derivationExpr;
	}
	
	/**
	 * Set a value to attribute derivationExpr.
	 * @param derivationExpr.
	 */
	public void setDerivationExpr(net.ihe.gazelle.datatypes.ST derivationExpr) {
	    this.derivationExpr = derivationExpr;
	}
	
	
	
	
	/**
	 * Return text.
	 * @return text
	 */
	public net.ihe.gazelle.datatypes.ED getText() {
	    return text;
	}
	
	/**
	 * Set a value to attribute text.
	 * @param text.
	 */
	public void setText(net.ihe.gazelle.datatypes.ED text) {
	    this.text = text;
	}
	
	
	
	
	/**
	 * Return statusCode.
	 * @return statusCode
	 */
	public net.ihe.gazelle.datatypes.CS getStatusCode() {
	    return statusCode;
	}
	
	/**
	 * Set a value to attribute statusCode.
	 * @param statusCode.
	 */
	public void setStatusCode(net.ihe.gazelle.datatypes.CS statusCode) {
	    this.statusCode = statusCode;
	}
	
	
	
	
	/**
	 * Return effectiveTime.
	 * @return effectiveTime
	 */
	public net.ihe.gazelle.datatypes.IVLTS getEffectiveTime() {
	    return effectiveTime;
	}
	
	/**
	 * Set a value to attribute effectiveTime.
	 * @param effectiveTime.
	 */
	public void setEffectiveTime(net.ihe.gazelle.datatypes.IVLTS effectiveTime) {
	    this.effectiveTime = effectiveTime;
	}
	
	
	
	
	/**
	 * Return priorityCode.
	 * @return priorityCode
	 */
	public net.ihe.gazelle.datatypes.CE getPriorityCode() {
	    return priorityCode;
	}
	
	/**
	 * Set a value to attribute priorityCode.
	 * @param priorityCode.
	 */
	public void setPriorityCode(net.ihe.gazelle.datatypes.CE priorityCode) {
	    this.priorityCode = priorityCode;
	}
	
	
	
	
	/**
	 * Return repeatNumber.
	 * @return repeatNumber
	 */
	public net.ihe.gazelle.datatypes.IVLINT getRepeatNumber() {
	    return repeatNumber;
	}
	
	/**
	 * Set a value to attribute repeatNumber.
	 * @param repeatNumber.
	 */
	public void setRepeatNumber(net.ihe.gazelle.datatypes.IVLINT repeatNumber) {
	    this.repeatNumber = repeatNumber;
	}
	
	
	
	
	/**
	 * Return languageCode.
	 * @return languageCode
	 */
	public net.ihe.gazelle.datatypes.CS getLanguageCode() {
	    return languageCode;
	}
	
	/**
	 * Set a value to attribute languageCode.
	 * @param languageCode.
	 */
	public void setLanguageCode(net.ihe.gazelle.datatypes.CS languageCode) {
	    this.languageCode = languageCode;
	}
	
	
	
	
	/**
	 * Return value.
	 * @return value
	 */
	public List<net.ihe.gazelle.datatypes.ANY> getValue() {
		if (value == null) {
	        value = new ArrayList<net.ihe.gazelle.datatypes.ANY>();
	    }
	    return value;
	}
	
	/**
	 * Set a value to attribute value.
	 * @param value.
	 */
	public void setValue(List<net.ihe.gazelle.datatypes.ANY> value) {
	    this.value = value;
	}
	
	
	
	/**
	 * Add a value to the value collection.
	 * @param value_elt Element to add.
	 */
	public void addValue(net.ihe.gazelle.datatypes.ANY value_elt) {
	    this.value.add(value_elt);
	}
	
	/**
	 * Remove a value to the value collection.
	 * @param value_elt Element to remove
	 */
	public void removeValue(net.ihe.gazelle.datatypes.ANY value_elt) {
	    this.value.remove(value_elt);
	}
	
	/**
	 * Return interpretationCode.
	 * @return interpretationCode
	 */
	public List<net.ihe.gazelle.datatypes.CE> getInterpretationCode() {
		if (interpretationCode == null) {
	        interpretationCode = new ArrayList<net.ihe.gazelle.datatypes.CE>();
	    }
	    return interpretationCode;
	}
	
	/**
	 * Set a value to attribute interpretationCode.
	 * @param interpretationCode.
	 */
	public void setInterpretationCode(List<net.ihe.gazelle.datatypes.CE> interpretationCode) {
	    this.interpretationCode = interpretationCode;
	}
	
	
	
	/**
	 * Add a interpretationCode to the interpretationCode collection.
	 * @param interpretationCode_elt Element to add.
	 */
	public void addInterpretationCode(net.ihe.gazelle.datatypes.CE interpretationCode_elt) {
	    this.interpretationCode.add(interpretationCode_elt);
	}
	
	/**
	 * Remove a interpretationCode to the interpretationCode collection.
	 * @param interpretationCode_elt Element to remove
	 */
	public void removeInterpretationCode(net.ihe.gazelle.datatypes.CE interpretationCode_elt) {
	    this.interpretationCode.remove(interpretationCode_elt);
	}
	
	/**
	 * Return methodCode.
	 * @return methodCode
	 */
	public List<net.ihe.gazelle.datatypes.CE> getMethodCode() {
		if (methodCode == null) {
	        methodCode = new ArrayList<net.ihe.gazelle.datatypes.CE>();
	    }
	    return methodCode;
	}
	
	/**
	 * Set a value to attribute methodCode.
	 * @param methodCode.
	 */
	public void setMethodCode(List<net.ihe.gazelle.datatypes.CE> methodCode) {
	    this.methodCode = methodCode;
	}
	
	
	
	/**
	 * Add a methodCode to the methodCode collection.
	 * @param methodCode_elt Element to add.
	 */
	public void addMethodCode(net.ihe.gazelle.datatypes.CE methodCode_elt) {
	    this.methodCode.add(methodCode_elt);
	}
	
	/**
	 * Remove a methodCode to the methodCode collection.
	 * @param methodCode_elt Element to remove
	 */
	public void removeMethodCode(net.ihe.gazelle.datatypes.CE methodCode_elt) {
	    this.methodCode.remove(methodCode_elt);
	}
	
	/**
	 * Return targetSiteCode.
	 * @return targetSiteCode
	 */
	public List<net.ihe.gazelle.datatypes.CD> getTargetSiteCode() {
		if (targetSiteCode == null) {
	        targetSiteCode = new ArrayList<net.ihe.gazelle.datatypes.CD>();
	    }
	    return targetSiteCode;
	}
	
	/**
	 * Set a value to attribute targetSiteCode.
	 * @param targetSiteCode.
	 */
	public void setTargetSiteCode(List<net.ihe.gazelle.datatypes.CD> targetSiteCode) {
	    this.targetSiteCode = targetSiteCode;
	}
	
	
	
	/**
	 * Add a targetSiteCode to the targetSiteCode collection.
	 * @param targetSiteCode_elt Element to add.
	 */
	public void addTargetSiteCode(net.ihe.gazelle.datatypes.CD targetSiteCode_elt) {
	    this.targetSiteCode.add(targetSiteCode_elt);
	}
	
	/**
	 * Remove a targetSiteCode to the targetSiteCode collection.
	 * @param targetSiteCode_elt Element to remove
	 */
	public void removeTargetSiteCode(net.ihe.gazelle.datatypes.CD targetSiteCode_elt) {
	    this.targetSiteCode.remove(targetSiteCode_elt);
	}
	
	/**
	 * Return subject.
	 * @return subject
	 */
	public net.ihe.gazelle.cda.POCDMT000040Subject getSubject() {
	    return subject;
	}
	
	/**
	 * Set a value to attribute subject.
	 * @param subject.
	 */
	public void setSubject(net.ihe.gazelle.cda.POCDMT000040Subject subject) {
	    this.subject = subject;
	}
	
	
	
	
	/**
	 * Return specimen.
	 * @return specimen
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040Specimen> getSpecimen() {
		if (specimen == null) {
	        specimen = new ArrayList<net.ihe.gazelle.cda.POCDMT000040Specimen>();
	    }
	    return specimen;
	}
	
	/**
	 * Set a value to attribute specimen.
	 * @param specimen.
	 */
	public void setSpecimen(List<net.ihe.gazelle.cda.POCDMT000040Specimen> specimen) {
	    this.specimen = specimen;
	}
	
	
	
	/**
	 * Add a specimen to the specimen collection.
	 * @param specimen_elt Element to add.
	 */
	public void addSpecimen(net.ihe.gazelle.cda.POCDMT000040Specimen specimen_elt) {
	    this.specimen.add(specimen_elt);
	}
	
	/**
	 * Remove a specimen to the specimen collection.
	 * @param specimen_elt Element to remove
	 */
	public void removeSpecimen(net.ihe.gazelle.cda.POCDMT000040Specimen specimen_elt) {
	    this.specimen.remove(specimen_elt);
	}
	
	/**
	 * Return performer.
	 * @return performer
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040Performer2> getPerformer() {
		if (performer == null) {
	        performer = new ArrayList<net.ihe.gazelle.cda.POCDMT000040Performer2>();
	    }
	    return performer;
	}
	
	/**
	 * Set a value to attribute performer.
	 * @param performer.
	 */
	public void setPerformer(List<net.ihe.gazelle.cda.POCDMT000040Performer2> performer) {
	    this.performer = performer;
	}
	
	
	
	/**
	 * Add a performer to the performer collection.
	 * @param performer_elt Element to add.
	 */
	public void addPerformer(net.ihe.gazelle.cda.POCDMT000040Performer2 performer_elt) {
	    this.performer.add(performer_elt);
	}
	
	/**
	 * Remove a performer to the performer collection.
	 * @param performer_elt Element to remove
	 */
	public void removePerformer(net.ihe.gazelle.cda.POCDMT000040Performer2 performer_elt) {
	    this.performer.remove(performer_elt);
	}
	
	/**
	 * Return author.
	 * @return author
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040Author> getAuthor() {
		if (author == null) {
	        author = new ArrayList<net.ihe.gazelle.cda.POCDMT000040Author>();
	    }
	    return author;
	}
	
	/**
	 * Set a value to attribute author.
	 * @param author.
	 */
	public void setAuthor(List<net.ihe.gazelle.cda.POCDMT000040Author> author) {
	    this.author = author;
	}
	
	
	
	/**
	 * Add a author to the author collection.
	 * @param author_elt Element to add.
	 */
	public void addAuthor(net.ihe.gazelle.cda.POCDMT000040Author author_elt) {
	    this.author.add(author_elt);
	}
	
	/**
	 * Remove a author to the author collection.
	 * @param author_elt Element to remove
	 */
	public void removeAuthor(net.ihe.gazelle.cda.POCDMT000040Author author_elt) {
	    this.author.remove(author_elt);
	}
	
	/**
	 * Return informant.
	 * @return informant
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040Informant12> getInformant() {
		if (informant == null) {
	        informant = new ArrayList<net.ihe.gazelle.cda.POCDMT000040Informant12>();
	    }
	    return informant;
	}
	
	/**
	 * Set a value to attribute informant.
	 * @param informant.
	 */
	public void setInformant(List<net.ihe.gazelle.cda.POCDMT000040Informant12> informant) {
	    this.informant = informant;
	}
	
	
	
	/**
	 * Add a informant to the informant collection.
	 * @param informant_elt Element to add.
	 */
	public void addInformant(net.ihe.gazelle.cda.POCDMT000040Informant12 informant_elt) {
	    this.informant.add(informant_elt);
	}
	
	/**
	 * Remove a informant to the informant collection.
	 * @param informant_elt Element to remove
	 */
	public void removeInformant(net.ihe.gazelle.cda.POCDMT000040Informant12 informant_elt) {
	    this.informant.remove(informant_elt);
	}
	
	/**
	 * Return participant.
	 * @return participant
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040Participant2> getParticipant() {
		if (participant == null) {
	        participant = new ArrayList<net.ihe.gazelle.cda.POCDMT000040Participant2>();
	    }
	    return participant;
	}
	
	/**
	 * Set a value to attribute participant.
	 * @param participant.
	 */
	public void setParticipant(List<net.ihe.gazelle.cda.POCDMT000040Participant2> participant) {
	    this.participant = participant;
	}
	
	
	
	/**
	 * Add a participant to the participant collection.
	 * @param participant_elt Element to add.
	 */
	public void addParticipant(net.ihe.gazelle.cda.POCDMT000040Participant2 participant_elt) {
	    this.participant.add(participant_elt);
	}
	
	/**
	 * Remove a participant to the participant collection.
	 * @param participant_elt Element to remove
	 */
	public void removeParticipant(net.ihe.gazelle.cda.POCDMT000040Participant2 participant_elt) {
	    this.participant.remove(participant_elt);
	}
	
	/**
	 * Return entryRelationship.
	 * @return entryRelationship
	 */
	public List<net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship> getEntryRelationship() {
		if (entryRelationship == null) {
	        entryRelationship = new ArrayList<net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship>();
	    }
	    return entryRelationship;
	}
	
	/**
	 * Set a value to attribute entryRelationship.
	 * @param entryRelationship.
	 */
	public void setEntryRelationship(List<net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship> entryRelationship) {
	    this.entryRelationship = entryRelationship;
	}
	
	
	
	/**
	 * Add a entryRelationship to the entryRelationship collection.
	 * @param entryRelationship_elt Element to add.
	 */
	public void addEntryRelationship(net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship entryRelationship_elt) {
	    this.entryRelationship.add(entryRelationship_elt);
	}
	
	/**
	 * Remove a entryRelationship to the entryRelationship collection.
	 * @param entryRelationship_elt Element to remove
	 */
	public void removeEntryRelationship(net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship entryRelationship_elt) {
	    this.entryRelationship.remove(entryRelationship_elt);
	}
	
	/**
	 * Return reference.
	 * @return reference
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040Reference> getReference() {
		if (reference == null) {
	        reference = new ArrayList<net.ihe.gazelle.cda.POCDMT000040Reference>();
	    }
	    return reference;
	}
	
	/**
	 * Set a value to attribute reference.
	 * @param reference.
	 */
	public void setReference(List<net.ihe.gazelle.cda.POCDMT000040Reference> reference) {
	    this.reference = reference;
	}
	
	
	
	/**
	 * Add a reference to the reference collection.
	 * @param reference_elt Element to add.
	 */
	public void addReference(net.ihe.gazelle.cda.POCDMT000040Reference reference_elt) {
	    this.reference.add(reference_elt);
	}
	
	/**
	 * Remove a reference to the reference collection.
	 * @param reference_elt Element to remove
	 */
	public void removeReference(net.ihe.gazelle.cda.POCDMT000040Reference reference_elt) {
	    this.reference.remove(reference_elt);
	}
	
	/**
	 * Return precondition.
	 * @return precondition
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040Precondition> getPrecondition() {
		if (precondition == null) {
	        precondition = new ArrayList<net.ihe.gazelle.cda.POCDMT000040Precondition>();
	    }
	    return precondition;
	}
	
	/**
	 * Set a value to attribute precondition.
	 * @param precondition.
	 */
	public void setPrecondition(List<net.ihe.gazelle.cda.POCDMT000040Precondition> precondition) {
	    this.precondition = precondition;
	}
	
	
	
	/**
	 * Add a precondition to the precondition collection.
	 * @param precondition_elt Element to add.
	 */
	public void addPrecondition(net.ihe.gazelle.cda.POCDMT000040Precondition precondition_elt) {
	    this.precondition.add(precondition_elt);
	}
	
	/**
	 * Remove a precondition to the precondition collection.
	 * @param precondition_elt Element to remove
	 */
	public void removePrecondition(net.ihe.gazelle.cda.POCDMT000040Precondition precondition_elt) {
	    this.precondition.remove(precondition_elt);
	}
	
	/**
	 * Return referenceRange.
	 * @return referenceRange
	 */
	public List<net.ihe.gazelle.cda.POCDMT000040ReferenceRange> getReferenceRange() {
		if (referenceRange == null) {
	        referenceRange = new ArrayList<net.ihe.gazelle.cda.POCDMT000040ReferenceRange>();
	    }
	    return referenceRange;
	}
	
	/**
	 * Set a value to attribute referenceRange.
	 * @param referenceRange.
	 */
	public void setReferenceRange(List<net.ihe.gazelle.cda.POCDMT000040ReferenceRange> referenceRange) {
	    this.referenceRange = referenceRange;
	}
	
	
	
	/**
	 * Add a referenceRange to the referenceRange collection.
	 * @param referenceRange_elt Element to add.
	 */
	public void addReferenceRange(net.ihe.gazelle.cda.POCDMT000040ReferenceRange referenceRange_elt) {
	    this.referenceRange.add(referenceRange_elt);
	}
	
	/**
	 * Remove a referenceRange to the referenceRange collection.
	 * @param referenceRange_elt Element to remove
	 */
	public void removeReferenceRange(net.ihe.gazelle.cda.POCDMT000040ReferenceRange referenceRange_elt) {
	    this.referenceRange.remove(referenceRange_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.ActClassObservation getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.ActClassObservation classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return moodCode.
	 * @return moodCode
	 */
	public net.ihe.gazelle.voc.XActMoodDocumentObservation getMoodCode() {
	    return moodCode;
	}
	
	/**
	 * Set a value to attribute moodCode.
	 * @param moodCode.
	 */
	public void setMoodCode(net.ihe.gazelle.voc.XActMoodDocumentObservation moodCode) {
	    this.moodCode = moodCode;
	}
	
	
	
	
	/**
	 * Return negationInd.
	 * @return negationInd
	 */
	public Boolean getNegationInd() {
	    return negationInd;
	}
	
	/**
	 * Set a value to attribute negationInd.
	 * @param negationInd.
	 */
	public void setNegationInd(Boolean negationInd) {
	    this.negationInd = negationInd;
	}
	
	
	/**
	 * Return negationInd.
	 * @return negationInd
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public Boolean isNegationInd() {
	    return negationInd;
	}
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Observation").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Observation pOCDMT000040Observation, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Observation != null){
   			cvm.validate(pOCDMT000040Observation, location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Observation.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Observation.getTypeId(), location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Observation.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II id: pOCDMT000040Observation.getId()){
					net.ihe.gazelle.datatypes.II.validateByModule(id, location + "/id[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.CD.validateByModule(pOCDMT000040Observation.getCode(), location + "/code", cvm, diagnostic);
			net.ihe.gazelle.datatypes.ST.validateByModule(pOCDMT000040Observation.getDerivationExpr(), location + "/derivationExpr", cvm, diagnostic);
			net.ihe.gazelle.datatypes.ED.validateByModule(pOCDMT000040Observation.getText(), location + "/text", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CS.validateByModule(pOCDMT000040Observation.getStatusCode(), location + "/statusCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.IVLTS.validateByModule(pOCDMT000040Observation.getEffectiveTime(), location + "/effectiveTime", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Observation.getPriorityCode(), location + "/priorityCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.IVLINT.validateByModule(pOCDMT000040Observation.getRepeatNumber(), location + "/repeatNumber", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CS.validateByModule(pOCDMT000040Observation.getLanguageCode(), location + "/languageCode", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.ANY value: pOCDMT000040Observation.getValue()){
					net.ihe.gazelle.datatypes.ANY.validateByModule(value, location + "/value[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CE interpretationCode: pOCDMT000040Observation.getInterpretationCode()){
					net.ihe.gazelle.datatypes.CE.validateByModule(interpretationCode, location + "/interpretationCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CE methodCode: pOCDMT000040Observation.getMethodCode()){
					net.ihe.gazelle.datatypes.CE.validateByModule(methodCode, location + "/methodCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CD targetSiteCode: pOCDMT000040Observation.getTargetSiteCode()){
					net.ihe.gazelle.datatypes.CD.validateByModule(targetSiteCode, location + "/targetSiteCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cda.POCDMT000040Subject.validateByModule(pOCDMT000040Observation.getSubject(), location + "/subject", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040Specimen specimen: pOCDMT000040Observation.getSpecimen()){
					net.ihe.gazelle.cda.POCDMT000040Specimen.validateByModule(specimen, location + "/specimen[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040Performer2 performer: pOCDMT000040Observation.getPerformer()){
					net.ihe.gazelle.cda.POCDMT000040Performer2.validateByModule(performer, location + "/performer[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040Author author: pOCDMT000040Observation.getAuthor()){
					net.ihe.gazelle.cda.POCDMT000040Author.validateByModule(author, location + "/author[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040Informant12 informant: pOCDMT000040Observation.getInformant()){
					net.ihe.gazelle.cda.POCDMT000040Informant12.validateByModule(informant, location + "/informant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040Participant2 participant: pOCDMT000040Observation.getParticipant()){
					net.ihe.gazelle.cda.POCDMT000040Participant2.validateByModule(participant, location + "/participant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship entryRelationship: pOCDMT000040Observation.getEntryRelationship()){
					net.ihe.gazelle.cdaepsos.POCDMT000040EntryRelationship.validateByModule(entryRelationship, location + "/entryRelationship[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040Reference reference: pOCDMT000040Observation.getReference()){
					net.ihe.gazelle.cda.POCDMT000040Reference.validateByModule(reference, location + "/reference[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040Precondition precondition: pOCDMT000040Observation.getPrecondition()){
					net.ihe.gazelle.cda.POCDMT000040Precondition.validateByModule(precondition, location + "/precondition[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.cda.POCDMT000040ReferenceRange referenceRange: pOCDMT000040Observation.getReferenceRange()){
					net.ihe.gazelle.cda.POCDMT000040ReferenceRange.validateByModule(referenceRange, location + "/referenceRange[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}